Attribute VB_Name = "ini"
Option Explicit


Const IniFileName = "\pc_thermometer.INI"
Private IniFileDirectory As String


Declare Function GetPrivateProfileStringA% Lib "Kernel32" (ByVal ApplicationName$, ByVal KeyName$, ByVal Default$, ByVal ReturndString$, ByVal Size%, ByVal FileName$)
Declare Function WritePrivateProfileStringA% Lib "Kernel32" (ByVal ApplicationName$, ByVal KeyName$, ByVal StringToWrite$, ByVal FileName$)


Public Sub WriteIniString(ByVal key As String, ByVal Value As String)
    If WritePrivateProfileStringA("ARB", key, Value, IniFileDirectory + IniFileName) <> True Then
    End If
End Sub


Public Function ReadIniString(key As String, Default As String)
Dim ReturnedString As String
    ReturnedString = Space$(128)
    If Not GetPrivateProfileStringA%("ARB", key, Default, ReturnedString, 128, IniFileDirectory + IniFileName) <> True Then
        MsgBox "INI file is invalid or does not exist."
    End If
    ReadIniString = Trim(ReturnedString)
End Function

Public Sub ReadIni()
    Dim i As Integer
    Dim C As Control
    'useful when developing...
    IniFileDirectory = CurDir$
    If IniFileDirectory = "C:\Programmi\DevStudio\VB" Then
        IniFileDirectory = "C:\Alberto\DS1621"
    End If
    'check for INI file
    If Left$(ReadIniString("FileId", "None"), 5) <> "therm" Then
        MsgBox "Unable to find Startup file" + Chr$(13) + IniFileDirectory + "\" + IniFileName + Chr$(13) + Chr$(13) + "Using defaults", , "Error"
    
    Else
        On Error Resume Next
        For Each C In frm_thermometer.Controls
            C.Caption = ReadIniString("frm_thermometer." + C.Name + ".caption", C.Caption)
            C.Value = Val(ReadIniString("frm_thermometer." + C.Name + ".value", C.Value))
        Next
        On Error GoTo 0
    End If
End Sub

Public Sub SaveIni()
    Dim i As Integer
    Dim C As Control
    WriteIniString "FileId", "therm"
    On Error Resume Next
    For Each C In frm_thermometer.Controls
        WriteIniString "frm_thermometer." + C.Name + ".caption", C.Caption
        If TypeOf C Is CheckBox Or TypeOf C Is OptionButton Then
            If C.Value Then
                WriteIniString "frm_thermometer." + C.Name + ".value", 1
            Else
                WriteIniString "frm_thermometer." + C.Name + ".value", 0
            End If
        Else
            WriteIniString "frm_thermometer." + C.Name + ".value", C.Value
        End If
    Next
    On Error GoTo 0
End Sub



